## ettercap 0.8.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(ettercap C)

set(VERSION "0.8.2")

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules")
set(CMAKE_SCRIPT_PATH "${CMAKE_SOURCE_DIR}/cmake/Scripts")

include(MacroEnsureOutOfSourceBuild)
macro_ensure_out_of_source_build("${PROJECT_NAME} requires an out of source build.
Please create a separate build directory and run 'cmake /path/to/${PROJECT_NAME} [options]' there.")

option(ENABLE_CURSES "Enable curses interface" ON)
option(ENABLE_GTK "Enable GTK interface" ON)
option(ENABLE_PLUGINS "Enable plugins support" ON)
option(ENABLE_IPV6 "Enable IPv6 support" OFF)
option(ENABLE_LUA "Enable LUA support (EXPERIMENTAL)" OFF)
option(ENABLE_PDF_DOCS "Enable PDF document generation" OFF)
option(ENABLE_TESTS "Enable Unit Tests" OFF)
option(ENABLE_GEOIP "Build with GeoIP support" ON)
option(LIBRARY_BUILD "Build for libettercap only" OFF)
option(INSTALL_DESKTOP "Install ettercap desktop files" ON)


set(VALID_BUILD_TYPES Debug Release RelWithDebInfo)

if(NOT CMAKE_BUILD_TYPE)
  # Default to using "Release" as our build type.
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING
    "Choose the type of build, options are: ${VALID_BUILD_TYPES}." FORCE)
endif()
list(FIND VALID_BUILD_TYPES ${CMAKE_BUILD_TYPE} contains_valid)
if(contains_valid EQUAL -1)
  message(FATAL_ERROR "Unknown CMAKE_BUILD_TYPE: '${CMAKE_BUILD_TYPE}'. Valid options are: ${VALID_BUILD_TYPES}")
endif()
unset(contains_valid)

include(CMakeDependentOption)

# If SYSTEM_LIBS is set to off, then all SYSTEM_* options will be
# set to off.
option(SYSTEM_LIBS "Search for system-provided libraries.
This is only used for libraries that we happen to also bundle.
Disabling this implies that we would only use bundled libraries." ON)

# If BUNDLED_LIBS is set to off, then all BUNDLED_* options will be
# set to off.
option(BUNDLED_LIBS
  "Use bundled libraries if system provided versions are not found (or disabled)" ON)

cmake_dependent_option(SYSTEM_CURL
  "Search for a system-provided version of Curl" ON
  SYSTEM_LIBS OFF)

cmake_dependent_option(BUNDLED_CURL
  "Use bundled version of Curl if system-provided version is not found (or disabled)" ON
  BUNDLED_LIBS OFF)

cmake_dependent_option(SYSTEM_LIBNET
  "Search for a system-provided version of LIBNET" ON
  SYSTEM_LIBS OFF)

cmake_dependent_option(BUNDLED_LIBNET
  "Use bundled version of LIBNET if system-provided version is not found (or disabled)" ON
  BUNDLED_LIBS OFF)

cmake_dependent_option(SYSTEM_LUAJIT
  "Search for a system-provided version of LUAJIT" ON
  "SYSTEM_LIBS;ENABLE_LUA" OFF)

cmake_dependent_option(BUNDLED_LUAJIT
  "Use bundled version of LUAJIT if system-provided version is not found (or disabled)" ON
  "BUNDLED_LIBS;ENABLE_LUA" OFF)

if(ENABLE_TESTS)
cmake_dependent_option(SYSTEM_LIBCHECK
  "Search for a system-provided version of LIBCHECK" ON
  SYSTEM_LIBS OFF)

cmake_dependent_option(BUNDLED_LIBCHECK
  "Use bundled version of LIBCHECK if system-provided version is not found (or disabled)" ON
  BUNDLED_LIBS OFF)
endif()

set(SPECIAL_LIB_DIR "" CACHE PATH "Special (non-traditional) root directory where headers/libraries are installed")

include(CheckVariableInHeaders)
include(EttercapOSTest)

#Check and see if we're running Darwin, specify the CMAKE_LIBARY_PATH to do so
if(OS_DARWIN)
  set(CMAKE_SYSTEM_NAME Darwin)
  set(CMAKE_LIBRARY_PATH ${SPECIAL_LIB_DIR}/lib ${CMAKE_LIBRARY_PATH})
  set(CMAKE_INCLUDE_PATH ${SPECIAL_LIB_DIR}/include ${CMAKE_INCLUDE_PATH})
else()
  set(CMAKE_LIBRARY_PATH ${CMAKE_LIBRARY_PATH} /usr/lib64 /usr/lib32)
endif()

if(LIBRARY_BUILD)
  set(ENABLE_GTK OFF)
  set(ENABLE_CURSES OFF)
  set(JUST_LIBRARY 1)
endif()

include(EttercapHeadersCheck)
include(EttercapLibCheck)
include(EttercapVariableCheck)

set(INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX} CACHE PATH "Installation prefix")
set(INSTALL_SYSCONFDIR /etc CACHE PATH "System configuration directory")
set(INSTALL_LIBDIR ${INSTALL_PREFIX}/lib${LIB_SUFFIX} CACHE PATH "Library installation directory")
set(INSTALL_DATADIR ${INSTALL_PREFIX}/share CACHE PATH "Data installation directory")
set(INSTALL_EXECPREFIX ${INSTALL_PREFIX} CACHE PATH "")
set(INSTALL_BINDIR  ${INSTALL_PREFIX}/bin CACHE PATH "Binary files installation directory")
if(OS_DARWIN OR OS_WINDOWS)
  set(POLKIT_DIR ${INSTALL_PREFIX}/share/polkit-1/actions/ CACHE PATH "Polkit installation directory")
else()
#at least on ubuntu, polkit dir couldn't be /usr/local/share, but should be /usr/share
  set(POLKIT_DIR /usr/share/polkit-1/actions/ CACHE PATH "Polkit installation directory")
endif()
set(PKEXEC_INSTALL_WRAPPER org.pkexec.ettercap CACHE PATH "Name of the pkexec action file")
set(DESKTOP_DIR ${INSTALL_PREFIX}/share/applications/ CACHE PATH "Desktop file installation directory")
set(APPDATA_DIR ${INSTALL_PREFIX}/share/appdata/ CACHE PATH "Appdata file installation directory")
set(ICON_DIR ${INSTALL_PREFIX}/share/pixmaps CACHE PATH "Icon file installation directory")
set(MAN_INSTALLDIR ${INSTALL_PREFIX}/share/man CACHE PATH "Path for manual pages")

if(NOT DISABLE_RPATH)
  # Ensure that, when we link to stuff outside of our build path, we include the
  # library dir path in our RPATH.
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  set(CMAKE_MACOSX_RPATH 1)
endif()

# set general build flags for debug build-type
set(CMAKE_C_FLAGS_DEBUG "-O0 -ggdb3 -DDEBUG -Wall -Wno-pointer-sign -D_FORTIFY_SOURCE=2 -Wformat -Wformat-security -Werror=format-security -Wextra -Wredundant-decls" CACHE STRING "" FORCE)
## append ASAN build flags if compiler version has support
#if("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
#   if(CMAKE_C_COMPILER_VERSION VERSION_GREATER 4.8)
#      set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fsanitize=address
#         -fno-omit-frame-pointer" CACHE STRING "" FORCE)
#      message("Building with ASAN support (GNU compiler)")
#   else()
#      message("Building without ASAN support (GNU compiler)")
#   endif()
#elseif("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")
#   if(CMAKE_C_COMPILER_VERSION VERSION_GREATER 3.1)
#      set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fsanitize=address
#         -fno-omit-frame-pointer" CACHE STRING "" FORCE)
#      message("Building with ASAN support (Clang compiler)")
#   elseif(CMAKE_C_COMPILER_VERSION VERSION_GREATER 3.1)
#      message("Building without ASAN support (Clang compiler)")
#   endif()
#endif()

# set build flags for release build-type
set(CMAKE_C_FLAGS_RELEASE "-O2 -w -D_FORTIFY_SOURCE=2" CACHE STRING "" FORCE)

if(OS_DARWIN)
set(CMAKE_EXE_LINKER_FLAGS "-Wl" CACHE STRING "" FORCE)
set(CMAKE_EXE_LINKER_FLAGS_DEBUG "-Wl" CACHE STRING "" FORCE)
set(CMAKE_MODULE_LINKER_FLAGS "-Wl" CACHE STRING "" FORCE)
set(CMAKE_SHARED_LINKER_FLAGS "-undefined dynamic_lookup" CACHE STRING "" FORCE)
endif()

if(ENABLE_LUA)
  include(EttercapLuajit)
  set(HAVE_EC_LUA 1)
endif()

set(EC_INCLUDE_PATH ${CMAKE_CURRENT_BINARY_DIR}/include ${CMAKE_SOURCE_DIR}/include ${EC_INCLUDE})
include_directories(${EC_INCLUDE_PATH})

add_subdirectory(src)

if(INSTALL_DESKTOP)
  add_subdirectory(desktop)
endif()

if(HAVE_PLUGINS)
    if(OS_MINGW)
        message("Sorry, plugins support on Windows is currently unavailable")
    else()
        add_subdirectory(plug-ins)
    endif()
endif()
add_subdirectory(utils)
add_subdirectory(share)
add_subdirectory(man)

if(ENABLE_IPV6)
    set(WITH_IPV6 TRUE)
endif()

# This line should ALWAYS be after all options are defined
configure_file(include/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/include/config.h)

if(ENABLE_TESTS)
  enable_testing()
  add_subdirectory(tests)
endif()

# uninstall target
configure_file(
    "${CMAKE_SCRIPT_PATH}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

# Add a target that will ensure that the build directory is properly cleaned.
add_custom_target(clean-all
  COMMAND ${CMAKE_BUILD_TOOL} clean
  COMMAND ${CMAKE_COMMAND} -P ${CMAKE_SCRIPT_PATH}/clean-all.cmake
)

# If we notice that this isn't the first time they've run
if(NOT ("${CMAKE_CACHEFILE_DIR}" STREQUAL ""))
  message("")
  message("HAVING TROUBLE BUILDING ETTERCAP? ")
  message("")
  message("  1. Install any missing dependencies")
  message("  2. run 'make clean-all'")
  message("  3. run 'cmake ${CMAKE_SOURCE_DIR}'")
  message("")
endif()

include(FeatureSummary)
feature_summary(WHAT ALL)

=== desktop/CMakeLists.txt ===
if(ENABLE_GTK)
  configure_file(org.pkexec.ettercap.policy.in
    ${PKEXEC_INSTALL_WRAPPER}.policy @ONLY)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PKEXEC_INSTALL_WRAPPER}.policy DESTINATION ${POLKIT_DIR})
  install(FILES ettercap.desktop DESTINATION ${DESKTOP_DIR})
  install(FILES ettercap.appdata.xml DESTINATION ${APPDATA_DIR})
  install(PROGRAMS ettercap-pkexec DESTINATION ${INSTALL_BINDIR})
endif()

=== man/CMakeLists.txt ===
# Add man page custom target
if(ENABLE_PDF_DOCS)
  find_program(GROFF_EXECUTABLE NAMES groff)
  set(PDF_FILES)

# Check if groff supports PDF generation
  execute_process(COMMAND ${GROFF_EXECUTABLE} -Tpdf -V
  RESULT_VARIABLE GROFF_EXIT
  ERROR_VARIABLE GROFF_ERROR
  OUTPUT_QUIET)

  if(NOT ${GROFF_EXIT} STREQUAL 0)
    message(FATAL_ERROR "groff (at ${GROFF_EXECUTABLE}) does not seem to support PDF generation (${GROFF_EXIT}).
groff failed with output:\n${GROFF_ERROR}
Consider upgrading the groff installation.
Users of Debian-based distributions must also install the full groff package.")
  endif()
endif()

set(MAN_NAMES ettercap.8 etterfilter.8 etterlog.8 etter.conf.5)
set(MAN_FILES)

if(ENABLE_PLUGINS)
  set(MAN_NAMES ${MAN_NAMES} ettercap_plugins.8)
endif()

if(INSTALL_DESKTOP)
  set(MAN_NAMES ${MAN_NAMES} ettercap-pkexec.8)
endif()

if(ENABLE_CURSES)
  set(MAN_NAMES ${MAN_NAMES} ettercap_curses.8)
endif()

foreach(m IN LISTS MAN_NAMES)
  set(mf ${CMAKE_BINARY_DIR}/man/${m})
  list(APPEND MAN_FILES ${mf})

  if(ENABLE_PDF_DOCS)
    set(pdf ${CMAKE_BINARY_DIR}/man/${m}.pdf)

    add_custom_command(OUTPUT ${mf}.pdf
    COMMAND ${GROFF_EXECUTABLE} -mandoc -Tpdf ${mf} > ${pdf}
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "Creating PDF for ${mf}"
    VERBATIM)

    list(APPEND PDF_FILES ${pdf})
    install(FILES ${pdf} DESTINATION ${INSTALL_DATADIR}/ettercap/doc)
  endif()
endforeach()

add_custom_target(man ALL DEPENDS ${MAN_FILES})
if(ENABLE_PDF_DOCS)
  add_custom_target(pdf ALL DEPENDS ${PDF_FILES})
endif()

install(FILES ${CMAKE_BINARY_DIR}/man/ettercap.8
      ${CMAKE_BINARY_DIR}/man/etterfilter.8
      ${CMAKE_BINARY_DIR}/man/etterlog.8
DESTINATION ${MAN_INSTALLDIR}/man8/)
configure_file("ettercap.8.in" "ettercap.8")
configure_file("etterfilter.8.in" "etterfilter.8")
configure_file("etterlog.8.in" "etterlog.8")
configure_file("etter.conf.5.in" "etter.conf.5")

if(ENABLE_PLUGINS)
  install(FILES ${CMAKE_BINARY_DIR}/man/ettercap_plugins.8 DESTINATION ${MAN_INSTALLDIR}/man8/)
  configure_file("ettercap_plugins.8.in" "ettercap_plugins.8")
endif()

if(ENABLE_CURSES)
  install(FILES ${CMAKE_BINARY_DIR}/man/ettercap_curses.8 DESTINATION ${MAN_INSTALLDIR}/man8/)
  configure_file("ettercap_curses.8.in" "ettercap_curses.8")
endif()

if(INSTALL_DESKTOP)
  install(FILES ${CMAKE_BINARY_DIR}/man/ettercap-pkexec.8 DESTINATION ${MAN_INSTALLDIR}/man8/)
  configure_file("ettercap-pkexec.8.in" "ettercap-pkexec.8")
endif()

install(FILES ${CMAKE_BINARY_DIR}/man/etter.conf.5 DESTINATION ${MAN_INSTALLDIR}/man5/)

=== plug-ins/CMakeLists.txt ===
if(HAVE_PCRE)
  if(CURL_FOUND)
    add_library(sslstrip MODULE sslstrip/sslstrip.c)
    include_directories(${CURL_INCLUDE_DIR} ${PCRE_INCLUDE_DIR})
    add_dependencies(sslstrip curl)
    target_link_libraries(sslstrip ${CURL_LIBRARY} ${PCRE_LIBRARY})
    target_link_libraries(sslstrip lib_ettercap)
    set_target_properties(sslstrip PROPERTIES PREFIX "ec_")
    install(TARGETS sslstrip
        LIBRARY DESTINATION ${INSTALL_LIBDIR}/ettercap/
        PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
                    GROUP_READ GROUP_EXECUTE
                    WORLD_READ WORLD_EXECUTE)

  else()
    message(STATUS "Not building sslstrip plugin. Requires libcurl.")
  endif()
else()
  message(STATUS "Not building sslstrip plugin. Requires pcre.")
endif()

set(PLUGINS arp_cop
autoadd
chk_poison
dns_spoof
mdns_spoof
dos_attack
dummy
find_conn
find_ettercap
find_ip
finger
finger_submit
fraggle_attack
gre_relay
gw_discover
isolate
link_type
nbns_spoof
pptp_chapms1
pptp_clear
pptp_pap
pptp_reneg
rand_flood
remote_browser
reply_arp
repoison_arp
scan_poisoner
search_promisc
smb_clear
smb_down
krb5_downgrade
smurf_attack
stp_mangler)

foreach(plugin ${PLUGINS})
  add_library(${plugin} MODULE ${plugin}/${plugin}.c)
  set_target_properties(${plugin} PROPERTIES PREFIX "ec_")
  target_link_libraries(${plugin} lib_ettercap)
  install(TARGETS ${plugin}
        LIBRARY DESTINATION ${INSTALL_LIBDIR}/ettercap/
        PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
                    GROUP_READ GROUP_EXECUTE
                    WORLD_READ WORLD_EXECUTE)
endforeach()

if(NOT HAVE_DN_EXPAND)
  target_link_libraries(dns_spoof ${HAVE_RESOLV})
  target_link_libraries(mdns_spoof ${HAVE_RESOLV})
endif()

target_link_libraries(dos_attack ${HAVE_LIBNET})

=== share/CMakeLists.txt ===

if(ENABLE_IPV6)
  configure_file(etter.conf.v6 etter.conf COPYONLY)
else()
  configure_file(etter.conf.v4 etter.conf COPYONLY)
endif()

set(EC_CONFFILES
    etter.dns
    etter.mdns
    etter.nbns
)

set(EC_DATAFILES
    ettercap.png
    ettercap-small.png
    ettercap.svg
    etter.fields
    etter.filter
    etterfilter.cnt
    etter.filter.examples
    etter.filter.kill
    etter.filter.pcre
    etter.filter.ssh
    etterfilter.tbl
    etter.finger.mac
    etter.finger.os
    etterlog.dtd
    etter.mime
    etter.services
    etter.ssl.crt
    ../AUTHORS
)
if(NOT NO_INSTALL_LICENSE)
  set(EC_DATAFILES ${EC_DATAFILES} ../LICENSE)
endif()

foreach(f IN LISTS EC_DATAFILES EC_CONFFILES)
  configure_file(${f} ${f} COPYONLY)
endforeach()
install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/${EC_CONFFILES}
        ${CMAKE_CURRENT_BINARY_DIR}/etter.conf
        DESTINATION ${INSTALL_SYSCONFDIR}/ettercap)
install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/${EC_DATAFILES}
        DESTINATION ${INSTALL_DATADIR}/ettercap)

# since ettercap now uses this file as the application icon
# we still need the icon even if the desktop file is not being installed
if(ENABLE_GTK)
  install(FILES ettercap.svg DESTINATION ${ICON_DIR})
endif()

=== src/CMakeLists.txt ===
set(EC_SRC
    ec_asn1.c
    ec_mem.c
    ec_capture.c
    ec_checksum.c
    ec_conf.c
    ec_connbuf.c
    ec_conntrack.c
    ec_debug.c
    ec_decode.c
    ec_dispatcher.c
    ec_dissect.c
    ec_encryption_ccmp.c
    ec_encryption_tkip.c
    ec_encryption.c
    ec_error.c
    ec_exit.c
    ec_file.c
    ec_filter.c
    ec_fingerprint.c
    ec_format.c
    ec_globals.c
    ec_hash.c
    ec_hook.c
    ec_inet.c
    ec_inject.c
    ec_libettercap.c
    ec_log.c
    ec_manuf.c
    ec_mitm.c
    ec_network.c
    ec_packet.c
    ec_passive.c
    ec_plugins.c
    ec_poll.c
    ec_profiles.c
    ec_redirect.c
    ec_resolv.c
    ec_scan.c
    ec_send.c
    ec_services.c
    ec_session.c
    ec_set.c
    ec_signals.c
    ec_sleep.c
    ec_sniff_bridge.c
    ec_sniff.c
    ec_sniff_unified.c
    ec_socket.c
    ec_sslwrap.c
    ec_stats.c
    ec_streambuf.c
    ec_strings.c
    ec_threads.c
    ec_ui.c
    ec_utils.c

    dissectors/ec_bgp.c
    dissectors/ec_cvs.c
    dissectors/ec_dhcp.c
    dissectors/ec_ftp.c
    dissectors/ec_gg.c
    dissectors/ec_http.c
    dissectors/ec_icq.c
    dissectors/ec_imap.c
    dissectors/ec_irc.c
    dissectors/ec_iscsi.c
    dissectors/ec_kerberos.c
    dissectors/ec_ldap.c
    dissectors/ec_mdns.c
    dissectors/ec_mongodb.c
    dissectors/ec_mountd.c
    dissectors/ec_msn.c
    dissectors/ec_mysql.c
    dissectors/ec_nbns.c
    dissectors/ec_nntp.c
    dissectors/ec_o5logon.c
    dissectors/ec_ospf.c
    dissectors/ec_pop.c
    dissectors/ec_postgresql.c
    dissectors/ec_portmap.c
    dissectors/ec_radius.c
    dissectors/ec_rcon.c
    dissectors/ec_rip.c
    dissectors/ec_rlogin.c
    dissectors/ec_smb.c
    dissectors/ec_smtp.c
    dissectors/ec_snmp.c
    dissectors/ec_socks.c
    dissectors/ec_ssh.c
    dissectors/ec_telnet.c
    dissectors/ec_TN3270.c
    dissectors/ec_vnc.c
    dissectors/ec_vrrp.c
    dissectors/ec_x11.c
    dissectors/ec_ymsg.c

    mitm/ec_arp_poisoning.c
    mitm/ec_dhcp_spoofing.c
    mitm/ec_icmp_redirect.c
    mitm/ec_port_stealing.c

    protocols/ec_arp.c
    protocols/ec_cooked.c
    protocols/ec_erf.c
    protocols/ec_eth.c
    protocols/ec_fddi.c
    protocols/ec_gre.c
    protocols/ec_esp.c
    protocols/ec_icmp.c
    protocols/ec_ip.c
    protocols/ec_mpls.c
    protocols/ec_null.c
    protocols/ec_ppi.c
    protocols/ec_ppp.c
    protocols/ec_pppoe.c
    protocols/ec_rawip.c
    protocols/ec_tcp.c
    protocols/ec_tr.c
    protocols/ec_udp.c
    protocols/ec_vlan.c
    protocols/ec_wifi.c
    protocols/ec_wifi_eapol.c
    protocols/ec_wifi_prism.c
    protocols/ec_wifi_radiotap.c
)


if(HAVE_GEOIP)
  set(EC_SRC ${EC_SRC} ec_geoip.c)
endif()

if(ENABLE_IPV6)
  set(EC_SRC ${EC_SRC} protocols/ec_icmp6.c protocols/ec_ip6.c mitm/ec_ip6nd_poison.c)
endif()

if(HAVE_DN_EXPAND)
  set(EC_SRC ${EC_SRC} dissectors/ec_dns.c)
endif()

if(OS_LINUX)
  set(EC_SRC ${EC_SRC} os/ec_linux.c)
elseif(OS_BSD)
  set(EC_SRC ${EC_SRC} os/ec_bsd.c)
elseif(OS_DARWIN)
  set(EC_SRC ${EC_SRC} os/ec_darwin.c)
elseif(OS_MINGW)
  set(EC_SRC ${EC_SRC} os/ec_mingw.c)
elseif(OS_SOLARIS)
  set(EC_SRC ${EC_SRC} os/ec_solaris.c)
elseif(OS_GNU)
  set(EC_SRC ${EC_SRC} os/ec_gnu.c)
endif()

if(NOT HAVE_STRLCAT AND NOT HAVE_STRLCAT_FUNCTION)
  set(EC_SRC ${EC_SRC} missing/strlcat.c)
endif()

if(NOT HAVE_STRLCPY AND NOT HAVE_STRLCPY_FUNCTION)
  set(EC_SRC ${EC_SRC} missing/strlcpy.c)
endif()

if(NOT HAVE_STRSEP)
  set(EC_SRC ${EC_SRC} missing/strsep.c)
endif()

if(NOT HAVE_STRCASESTR)
  set(EC_SRC ${EC_SRC} missing/strcasestr.c)
endif()

if(NOT HAVE_MEMMEM)
  set(EC_SRC ${EC_SRC} missing/memmem.c)
endif()

if(NOT HAVE_MEMRCHR)
  set(EC_SRC ${EC_SRC} missing/memrchr.c)
endif()

if(NOT HAVE_BASENAME)
  set(EC_SRC ${EC_SRC} missing/basename.c)
endif()

if(NOT HAVE_STRNDUP)
  set(EC_SRC ${EC_SRC} missing/strndup.c)
endif()

if(NOT HAVE_GETOPT_LONG AND NOT HAVE_GETOPT_H)
  set(EC_SRC ${EC_SRC} missing/getopt.c)
endif()

add_library(lib_ettercap SHARED ${EC_SRC})
add_dependencies(lib_ettercap libnet)
target_link_libraries(lib_ettercap ec_interfaces ${EC_LIBS})

if(NOT LIBRARY_BUILD)
  add_subdirectory(interfaces)
  include_directories(interfaces/daemon interfaces/text)
  if(ENABLE_CURSES)
    include_directories(interfaces/curses interfaces/curses/widgets)
  endif()
  add_executable(ettercap ec_parser.c ec_main.c)
  target_link_libraries(ettercap lib_ettercap ${EC_LIBS})
  if(NOT DISABLE_RPATH)
    set_target_properties(ettercap PROPERTIES
    INSTALL_RPATH ${INSTALL_LIBDIR})
  endif()
endif()

# Only compile lua stuff if lua is enabled!
if(ENABLE_LUA)
  add_subdirectory(lua)
  target_link_libraries(lib_ettercap ec_lua ${LUAJIT_LIBRARY})
  if(OS_DARWIN AND (CMAKE_SIZEOF_VOID_P EQUAL 8))
    # On 64-bit OSX platforms, luajit requires the following flags to be added.
    # See: http://luajit.org/install.html
    target_link_libraries(ettercap "-pagezero_size 10000 -image_base 100000000")
  endif()
endif()

#if(NOT LIBRARY_BUILD)
  #target_link_libraries(lib_ettercap ec_interfaces ${EC_LIBS})
#else(NOT LIBRARY_BUILD)
  #target_link_libraries(lib_ettercap ${EC_LIBS})
#endif(NOT LIBRARY_BUILD)

set_target_properties(lib_ettercap PROPERTIES
  ENABLE_EXPORTS On
  #  LINK_INTERFACE_LIBRARIES ""
  OUTPUT_NAME ettercap
  VERSION ${VERSION}
  SOVERSION 0
  )

install(TARGETS lib_ettercap DESTINATION ${INSTALL_LIBDIR})
if(NOT LIBRARY_BUILD)
  install(TARGETS ettercap DESTINATION ${INSTALL_BINDIR})
endif()

=== src/interfaces/CMakeLists.txt ===
set(EC_TEXT_SRC
            text/ec_text.c
            text/ec_text_conn.c
            text/ec_text_display.c
            text/ec_text_plugin.c
            text/ec_text_profile.c
            text/ec_text_redirect.c
)
include_directories(text)

set(EC_DAEMON_SRC daemon/ec_daemon.c)
include_directories(daemon)

if(ENABLE_CURSES)
    set(EC_CURSES_SRC
                curses/ec_curses.c
                curses/ec_curses_filters.c
                curses/ec_curses_help.c
                curses/ec_curses_hosts.c
                curses/ec_curses_live.c
                curses/ec_curses_logging.c
                curses/ec_curses_mitm.c
                curses/ec_curses_offline.c
                curses/ec_curses_plugins.c
                curses/ec_curses_start.c
                curses/ec_curses_targets.c
                curses/ec_curses_view.c
                curses/ec_curses_view_connections.c
                curses/ec_curses_view_profiles.c
    )
    include_directories(curses)
    set(EC_WDG_SRC
                curses/widgets/wdg.c
                curses/widgets/wdg_compound.c
                curses/widgets/wdg_debug.c
                curses/widgets/wdg_dialog.c
                curses/widgets/wdg_dynlist.c
                curses/widgets/wdg_error.c
                curses/widgets/wdg_file.c
                curses/widgets/wdg_input.c
                curses/widgets/wdg_list.c
                curses/widgets/wdg_menu.c
                curses/widgets/wdg_panel.c
                curses/widgets/wdg_percentage.c
                curses/widgets/wdg_scroll.c
                curses/widgets/wdg_window.c
    )
    include_directories(curses/widgets)
#    add_library(ec_wdg STATIC ${EC_WDG_SRC})
#    target_link_libraries(ec_wdg ${EC_LIBS})
endif()

if(ENABLE_GTK)
  if("${GTK_BUILD_TYPE}" STREQUAL "GTK2" OR "${HAVE_GTK3COMPAT}")
    include_directories(gtk)
    set(EC_GTK_SRC
      gtk/ec_gtk.c
      gtk/ec_gtk_conf.c
      gtk/ec_gtk_filters.c
      gtk/ec_gtk_help.c
      gtk/ec_gtk_hosts.c
      gtk/ec_gtk_live.c
      gtk/ec_gtk_logging.c
      gtk/ec_gtk_menus.c
      gtk/ec_gtk_mitm.c
      gtk/ec_gtk_offline.c
      gtk/ec_gtk_plugins.c
      gtk/ec_gtk_redirect.c
      gtk/ec_gtk_start.c
      gtk/ec_gtk_targets.c
      gtk/ec_gtk_view.c
      gtk/ec_gtk_view_connections.c
      gtk/ec_gtk_view_profiles.c
)
  else()
    # full GTK3 support, using gtk3 code
    include_directories(gtk3)
    set(EC_GTK_SRC
      gtk3/ec_gtk3.c
      gtk3/ec_gtk3_conf.c
      gtk3/ec_gtk3_filters.c
      gtk3/ec_gtk3_help.c
      gtk3/ec_gtk3_hosts.c
      gtk3/ec_gtk3_live.c
      gtk3/ec_gtk3_logging.c
      gtk3/ec_gtk3_menus.c
      gtk3/ec_gtk3_mitm.c
      gtk3/ec_gtk3_offline.c
      gtk3/ec_gtk3_plugins.c
      gtk3/ec_gtk3_redirect.c
      gtk3/ec_gtk3_start.c
      gtk3/ec_gtk3_targets.c
      gtk3/ec_gtk3_view.c
      gtk3/ec_gtk3_view_connections.c
      gtk3/ec_gtk3_view_profiles.c
      gtk3/ec_gtk3_shortcuts.c
)
  endif()
endif()


add_library(ec_interfaces SHARED ../ec_interfaces.c
${EC_TEXT_SRC} ${EC_DAEMON_SRC} ${EC_WDG_SRC} ${EC_CURSES_SRC} ${EC_GTK_SRC})
set_target_properties(ec_interfaces PROPERTIES
  ENABLE_EXPORTS On
  POSITION_INDEPENDENT_CODE ON
  #  LINK_INTERFACE_LIBRARIES ""
  OUTPUT_NAME ettercap-ui
  VERSION ${VERSION}
  SOVERSION 0
  )
target_link_libraries(ec_interfaces ${EC_INTERFACES_LIBS} ${EC_LIBS})
install(TARGETS ec_interfaces DESTINATION ${INSTALL_LIBDIR})

=== src/lua/share/third-party/CMakeLists.txt ===

add_subdirectory(stdlib)

=== debian/changelog ===
ettercap (1:0.8.3-7) unstable; urgency=medium

  * Add patch proposed upstream to fix build with older libcheck implementations

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 30 Jan 2020 19:39:16 +0100

ettercap (1:0.8.3-6) unstable; urgency=high

  * debian/patches/977.patch:
    - upstream fix for host scan issue.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 03 Jan 2020 02:02:07 +0100

ettercap (1:0.8.3-5) unstable; urgency=medium

  * Update 955 pr patch with new URIs

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 02 Jan 2020 11:35:44 +0100

ettercap (1:0.8.3-4) unstable; urgency=medium

  * Move team maintenance under pkg-security umbrella
  * Update copyright years

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 02 Jan 2020 11:29:18 +0100

ettercap (1:0.8.3-3) unstable; urgency=medium

  * Drop build-dependency on ghostscript, we use groff now

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 22 Dec 2019 10:45:09 +0100

ettercap (1:0.8.3-2) unstable; urgency=medium

  * debian/patches/e57981ed56c04643d5a527897bb60894bf7bd96c.patch:
    - upstream various build fixes for new pango
  * debian/patches/988.patch
    - upstream-proposed build fix with new pango

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 21 Dec 2019 11:45:05 +0100

ettercap (1:0.8.3-1) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * New upstream release (Closes: #931361)
    - Default to gtk-3
  * Don't build against flex-old (Closes: #932513)
  * Add geoip to the build dependencies
  * Enable full hardening
  * Maintain the package under pkg-security team.
  * Drop patches, addressed upstream
  * Drop dbg package, useless now
  * Remove menu file
  * Update watch file location.
  * Bump compat level to 12
    - Drop old dh --list-missing
  * Bump std-version to 4.4.1, no changes required.
  * Update copyright file
  * Drop newlines from changelog file
  * Bump watch file to version 4
  * Bump download url to https
  * Cherry-pick three upstream PR: 951 954 955
    - Move appdata file into new metainfo location
    - typo fixes in manpages
    - Bump library version number
  * Move etterfilter and etterlog to subpackages, due to different
    libettercap-ui libraries.
  * Remove debian/NEWS file
  * Add R^3=no

  [ Ondřej Nový ]
  * d/changelog: Remove trailing whitespaces

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 20 Dec 2019 13:22:02 +0100

ettercap (1:0.8.2-10) unstable; urgency=low

  * Now that a lua-free ettercap is in testing,
    re-enable lua binding, waiting for luajit to be better.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 26 Sep 2017 11:08:03 +0200

ettercap (1:0.8.2-9) unstable; urgency=high

  * Disable lua binding for now, too much broken.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 26 Sep 2017 11:05:08 +0200

ettercap (1:0.8.2-8) unstable; urgency=medium

  * Re-enable lua binding, with my patch merged upstream
  * Trim the list of lua supported bindings

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 31 Aug 2017 06:45:24 +0200

ettercap (1:0.8.2-7) unstable; urgency=medium

  * Disable lua binding, thanks Adrian Bunk
    for the report! (Closes: #873320)
  * Bump std-version to 4.1.0, no changes required.
  * Switch VCS fields in https mode.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 27 Aug 2017 08:19:10 +0200

=== debian/control ===
Source: ettercap
Section: net
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Barak A. Pearlmutter <bap@debian.org>,
           Murat Demirten <murat@debian.org>,
           Gianfranco Costamagna <locutusofborg@debian.org>
Build-Depends: bison | bison++,
               check,
               chrpath,
               cmake,
               debhelper-compat (= 12),
               flex,
               groff,
               libbsd-dev,
               libcurl4-openssl-dev,
               libgeoip-dev,
               libgtk-3-dev,
               libltdl-dev,
               libluajit-5.1-dev [!s390x !alpha !hppa !m68k !powerpc !powerpcspe !sh4 !sparc64 !x32],
               libncurses5-dev,
               libnet1-dev,
               libpcap-dev,
               libpcre3-dev,
               libssl-dev
Standards-Version: 4.4.1
Homepage: https://ettercap.github.io/ettercap/
Vcs-Git: https://salsa.debian.org/pkg-security-team/ettercap.git
Vcs-Browser: https://salsa.debian.org/pkg-security-team/ettercap

Package: ettercap-common
Architecture: any
Depends: ethtool [linux-any],
         geoip-database,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: ettercap-graphical | ettercap-text-only
Description: Multipurpose sniffer/interceptor/logger for switched LAN
 Ettercap supports active and passive dissection of many protocols
 (even encrypted ones) and includes many feature for network and host
 analysis.
 .
 Data injection in an established connection and filtering (substitute
 or drop a packet) on the fly is also possible, keeping the connection
 synchronized.
 .
 Many sniffing modes are implemented, for a powerful and complete
 sniffing suite. It is possible to sniff in four modes: IP Based, MAC Based,
 ARP Based (full-duplex) and PublicARP Based (half-duplex).
 .
 Ettercap also has the ability to detect a switched LAN, and to use OS
 fingerprints (active or passive) to find the geometry of the LAN.
 .
 This package contains the Common support files, configuration files,
 plugins, and documentation.  You must also install either
 ettercap-graphical or ettercap-text-only for the actual GUI-enabled
 or text-only ettercap executable, respectively.

Package: ettercap-text-only
Architecture: any
Depends: ettercap-common (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: ettercap-common (<< 1:0.8.3-1~)
Replaces: ettercap-common (<< 1:0.8.3-1~), ettercap, ettercap-gtk
Conflicts: ettercap, ettercap-gtk
Provides: ettercap
Description: Ettercap console-mode executable
 Ettercap supports active and passive dissection of many protocols
 (even encrypted ones) and includes many feature for network and host
 analysis.
 .
 Data injection in an established connection and filtering (substitute
 or drop a packet) on the fly is also possible, keeping the connection
 synchronized.
 .
 Many sniffing modes are implemented, for a powerful and complete
 sniffing suite. It is possible to sniff in four modes: IP Based, MAC Based,
 ARP Based (full-duplex) and PublicARP Based (half-duplex).
 .
 Ettercap also has the ability to detect a switched LAN, and to use OS
 fingerprints (active or passive) to find the geometry of the LAN.
 .
 This package contains the ettercap text-mode-only executable.

Package: ettercap-graphical
Architecture: any
Depends: ettercap-common (= ${binary:Version}),
         policykit-1,
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: ettercap-common (<< 1:0.8.3-1~)
Replaces: ettercap, ettercap-common (<< 1:0.8.3-1~), ettercap-gtk
Conflicts: ettercap, ettercap-gtk
Provides: ettercap
Description: Ettercap GUI-enabled executable
 Ettercap supports active and passive dissection of many protocols
 (even encrypted ones) and includes many feature for network and host
 analysis.
 .
 Data injection in an established connection and filtering (substitute
 or drop a packet) on the fly is also possible, keeping the connection
 synchronized.
 .
 Many sniffing modes are implemented, for a powerful and complete
 sniffing suite. It is possible to sniff in four modes: IP Based, MAC Based,
 ARP Based (full-duplex) and PublicARP Based (half-duplex).
 .
 Ettercap also has the ability to detect a switched LAN, and to use OS
 fingerprints (active or passive) to find the geometry of the LAN.
 .
 This package contains the ettercap GUI-enabled executable.

## ettercap 0.8.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 2.8)
 project(ettercap C)
 
-set(VERSION "0.8.2")
+set(VERSION "0.8.3.1")
 
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules")
 set(CMAKE_SCRIPT_PATH "${CMAKE_SOURCE_DIR}/cmake/Scripts")
@@ -112,7 +112,7 @@
 set(INSTALL_DATADIR ${INSTALL_PREFIX}/share CACHE PATH "Data installation directory")
 set(INSTALL_EXECPREFIX ${INSTALL_PREFIX} CACHE PATH "")
 set(INSTALL_BINDIR  ${INSTALL_PREFIX}/bin CACHE PATH "Binary files installation directory")
-if(OS_DARWIN OR OS_WINDOWS)
+if(OS_DARWIN OR OS_BSD_FREE OR OS_WINDOWS)
   set(POLKIT_DIR ${INSTALL_PREFIX}/share/polkit-1/actions/ CACHE PATH "Polkit installation directory")
 else()
 #at least on ubuntu, polkit dir couldn't be /usr/local/share, but should be /usr/share
@@ -120,7 +120,7 @@
 endif()
 set(PKEXEC_INSTALL_WRAPPER org.pkexec.ettercap CACHE PATH "Name of the pkexec action file")
 set(DESKTOP_DIR ${INSTALL_PREFIX}/share/applications/ CACHE PATH "Desktop file installation directory")
-set(APPDATA_DIR ${INSTALL_PREFIX}/share/appdata/ CACHE PATH "Appdata file installation directory")
+set(METAINFO_DIR ${INSTALL_PREFIX}/share/metainfo/ CACHE PATH "Metainfo file installation directory")
 set(ICON_DIR ${INSTALL_PREFIX}/share/pixmaps CACHE PATH "Icon file installation directory")
 set(MAN_INSTALLDIR ${INSTALL_PREFIX}/share/man CACHE PATH "Path for manual pages")
 
@@ -132,7 +132,7 @@
 endif()
 
 # set general build flags for debug build-type
-set(CMAKE_C_FLAGS_DEBUG "-O0 -ggdb3 -DDEBUG -Wall -Wno-pointer-sign -D_FORTIFY_SOURCE=2 -Wformat -Wformat-security -Werror=format-security -Wextra -Wredundant-decls" CACHE STRING "" FORCE)
+set(CMAKE_C_FLAGS_DEBUG "-O0 -ggdb3 -DDEBUG -fno-common -Wall -Wno-pointer-sign -D_FORTIFY_SOURCE=2 -Wformat -Wformat-security -Werror=format-security -Wextra -Wredundant-decls" CACHE STRING "" FORCE)
 ## append ASAN build flags if compiler version has support
 #if("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
 #   if(CMAKE_C_COMPILER_VERSION VERSION_GREATER 4.8)
@@ -167,6 +167,10 @@
   set(HAVE_EC_LUA 1)
 endif()
 
+if(CURL_FOUND)
+  set(HAVE_CURL 1)
+endif()
+
 set(EC_INCLUDE_PATH ${CMAKE_CURRENT_BINARY_DIR}/include ${CMAKE_SOURCE_DIR}/include ${EC_INCLUDE})
 include_directories(${EC_INCLUDE_PATH})

=== desktop/CMakeLists.txt ===
if(ENABLE_GTK)
  configure_file(org.pkexec.ettercap.policy.in
    ${PKEXEC_INSTALL_WRAPPER}.policy @ONLY)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PKEXEC_INSTALL_WRAPPER}.policy DESTINATION ${POLKIT_DIR})
  install(FILES ettercap.desktop DESTINATION ${DESKTOP_DIR})
  install(FILES ettercap.metainfo.xml DESTINATION ${METAINFO_DIR})
  install(PROGRAMS ettercap-pkexec DESTINATION ${INSTALL_BINDIR})
endif()

=== share/CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,8 @@
     ettercap.png
     ettercap-small.png
     ettercap.svg
+    etter.dns.examples
+    etter.mdns.examples
     etter.fields
     etter.filter
     etterfilter.cnt

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -125,7 +125,6 @@
     protocols/ec_wifi_radiotap.c
 )
 
-
 if(HAVE_GEOIP)
   set(EC_SRC ${EC_SRC} ec_geoip.c)
 endif()
@@ -192,6 +191,10 @@
 add_dependencies(lib_ettercap libnet)
 target_link_libraries(lib_ettercap ec_interfaces ${EC_LIBS})
 
+if(CURL_FOUND)
+  target_link_libraries(lib_ettercap ${CURL_LIBRARY})
+endif()
+
 if(NOT LIBRARY_BUILD)
   add_subdirectory(interfaces)
   include_directories(interfaces/daemon interfaces/text)

=== tests/CMakeLists.txt ===

include_directories(. ../include ${LIBCHECK_INCLUDE_DIRS})

add_custom_target(test_verbose COMMAND ${CMAKE_CTEST_COMMAND} -V)

# Adds a test by name
macro(_t NAME)
  add_executable(test_${NAME} test_${NAME}.c)
  target_link_libraries(test_${NAME} lib_ettercap ec_interfaces
  ${LIBCHECK_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${LIBCHECK_LDFLAGS})
  add_test(test_${NAME} ${CMAKE_CURRENT_BINARY_DIR}/test_${NAME})
endmacro()

_t(ec_decode)

=== utils/CMakeLists.txt ===
## Etterfilter

set(EF_SRC
            etterfilter/ef_compiler.c
            etterfilter/ef_encode.c
            etterfilter/ef_main.c
            etterfilter/ef_output.c
            etterfilter/ef_parser.c
            etterfilter/ef_tables.c
            etterfilter/ef_test.c
)

find_package(BISON)
find_package(FLEX)
bison_target(EF_PARSER etterfilter/ef_grammar.y ${CMAKE_CURRENT_BINARY_DIR}/ef_grammar.c)
flex_target(EF_SCANNER etterfilter/ef_syntax.l ${CMAKE_CURRENT_BINARY_DIR}/ef_syntax.c)
add_flex_bison_dependency(EF_SCANNER EF_PARSER)

# For ef_grammar.h
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(etterfilter ${EF_SRC} ${FLEX_EF_SCANNER_OUTPUTS} ${BISON_EF_PARSER_OUTPUTS})
target_link_libraries(etterfilter lib_ettercap)
if(NOT DISABLE_RPATH)
  set_target_properties(etterfilter PROPERTIES INSTALL_RPATH ${INSTALL_LIBDIR})
endif()

## Etterlog

set(EL_SRC
            etterlog/el_analyze.c
            etterlog/el_conn.c
            etterlog/el_decode.c
            etterlog/el_decode_http.c
            etterlog/el_display.c
            etterlog/el_log.c
            etterlog/el_main.c
            etterlog/el_parser.c
            etterlog/el_profiles.c
            etterlog/el_stream.c
            etterlog/el_target.c
)

add_executable(etterlog ${EL_SRC})
target_link_libraries(etterlog lib_ettercap)

if(NOT DISABLE_RPATH)
  set_target_properties(etterlog PROPERTIES INSTALL_RPATH ${INSTALL_LIBDIR})
endif()
install(TARGETS etterfilter etterlog DESTINATION ${INSTALL_BINDIR})

=== src/lua/CMakeLists.txt ===

set(INSTALL_LUA_ROOT ${INSTALL_DATADIR}/ettercap/lua)
set(INSTALL_LUA_INIT ${INSTALL_LUA_ROOT}/init.lua)
set(INSTALL_LUA_CORE ${INSTALL_LUA_ROOT}/core)
set(INSTALL_LUA_LIBS ${INSTALL_LUA_ROOT}/lib)
set(INSTALL_LUA_THIRD_PARTY ${INSTALL_LUA_ROOT}/third-party)
set(INSTALL_LUA_SCRIPTS ${INSTALL_LUA_ROOT}/scripts)

configure_file(ec_lua_config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/include/ec_lua_config.h)

# Take care of building our C-based stuff.
include_directories(${CMAKE_CURRENT_BINARY_DIR}/include)
include_directories(${LUAJIT_INCLUDE_DIR})
add_library(ec_lua ec_lua.c)
set_target_properties(ec_lua PROPERTIES POSITION_INDEPENDENT_CODE ON)
add_dependencies(ec_lua luajit)

# Add our 'shared' code.
add_subdirectory(share)

=== src/lua/share/lib/CMakeLists.txt ===
# Nothing to install, just yet!
# install(FILES
#            ...
#            DESTINATION ${INSTALL_LUA_LIBS})

=== src/lua/share/third-party/stdlib/CMakeLists.txt ===

set(LUA_STDLIB_VERSION 34)
add_subdirectory(src)

=== src/lua/share/third-party/stdlib/src/CMakeLists.txt ===
file(GLOB lua_stdlib_files "*.lua")


set(VERSION ${LUA_STDLIB_VERSION})
configure_file(std.lua.in ${CMAKE_CURRENT_BINARY_DIR}/std.lua)

install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/std.lua
  ${lua_stdlib_files}
  DESTINATION ${INSTALL_LUA_THIRD_PARTY})

=== debian/changelog ===
ettercap (1:0.8.3.1-3) unstable; urgency=medium

  [ Samuel Henrique ]
  * Update debian/gbp.conf

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 01 Aug 2020 18:04:06 +0200

ettercap (1:0.8.3.1-2) unstable; urgency=medium

  * Refresh luajit architectures, to let ettercap build on riscv64

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 01 Aug 2020 17:44:32 +0200

ettercap (1:0.8.3.1-1) unstable; urgency=medium

  * New upstream release (Closes: #957180)
  * Fix copyright file (Closes: #951757)
  * New upstream version 0.8.3.1
  * Drop all patches, now upstream:
    - 1001
    - 951
    - 954
    - 955
    - 977
    - 988
    - e57981ed56c04643d5a527897bb60894bf7bd96c
  * Bump std-version to 4.5.0, no changes required
  * Set R^3: no

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 01 Aug 2020 16:59:47 +0200

=== debian/control ===
--- 
+++ 
@@ -17,13 +17,14 @@
                libgeoip-dev,
                libgtk-3-dev,
                libltdl-dev,
-               libluajit-5.1-dev [!s390x !alpha !hppa !m68k !powerpc !powerpcspe !sh4 !sparc64 !x32],
+               libluajit-5.1-dev [!s390x !alpha !hppa !ia64 !m68k !riscv64 !sh4 !sparc64 !x32],
                libncurses5-dev,
                libnet1-dev,
                libpcap-dev,
                libpcre3-dev,
                libssl-dev
-Standards-Version: 4.4.1
+Rules-Requires-Root: no
+Standards-Version: 4.5.0
 Homepage: https://ettercap.github.io/ettercap/
 Vcs-Git: https://salsa.debian.org/pkg-security-team/ettercap.git
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/ettercap

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
LIBNET_VER := $(shell dpkg --status libnet1-dev | awk '/^Version:/ {print $$2}')

ENABLE_IPV6 := $(shell \
 if dpkg --compare-versions $(LIBNET_VER) ge 1.1.6; \
 then echo ON; \
 else echo OFF; \
 fi)

ENABLE_LUA := $(shell \
 if pkg-config luajit; \
 then echo ON; \
 else echo OFF; \
 fi)

override_dh_auto_clean:
	-rm -rf obj-graphical obj-text-only

ETTERCAP_OPTIONS= \
 -DENABLE_IPV6=$(ENABLE_IPV6) \
 -DBUNDLED_LIBS=OFF \
 -DENABLE_LUA=$(ENABLE_LUA) \
 -DCMAKE_BUILD_TYPE=RelWithDebInfo \
 -DENABLE_TESTS=ON \
 -DDISABLE_RPATH=ON \
 -DNO_INSTALL_LICENSE=ON \
 -DENABLE_PDF_DOCS=ON
override_dh_auto_configure:
	@echo LIBNET_VER = $(LIBNET_VER)
	@echo ENABLE_IPV6 = $(ENABLE_IPV6)
	@echo ENABLE_LUA = $(ENABLE_LUA)
	dh_auto_configure --parallel --builddirectory=obj-text-only -- $(ETTERCAP_OPTIONS) -DENABLE_GTK=OFF
	dh_auto_configure --parallel --builddirectory=obj-graphical -- $(ETTERCAP_OPTIONS) -DENABLE_GTK=ON

override_dh_auto_build: override_dh_auto_build-text-only
override_dh_auto_build: override_dh_auto_build-graphical

override_dh_auto_build-text-only: ; dh_auto_build --parallel --builddirectory=obj-text-only
override_dh_auto_build-graphical: ; dh_auto_build --parallel --builddirectory=obj-graphical

override_dh_auto_test: override_dh_auto_test-text-only
override_dh_auto_test: override_dh_auto_test-graphical

override_dh_auto_test-text-only: ; dh_auto_test --parallel --builddirectory=obj-text-only
override_dh_auto_test-graphical: ; dh_auto_test --parallel --builddirectory=obj-graphical

override_dh_auto_install:
	dh_auto_install --parallel --builddirectory=obj-text-only
	mv debian/tmp/usr/lib/libettercap-ui.so* obj-text-only
	mv debian/tmp/usr/bin/* obj-text-only
	dh_auto_install --parallel --builddirectory=obj-graphical

override_dh_install:
	dh_install
	@echo The ettercap-pkexec man page belongs in ettercap-graphical
	-rm --verbose debian/ettercap-common/usr/share/ettercap/doc/ettercap-pkexec*
	-rm --verbose debian/ettercap-common/usr/share/man/man*/ettercap-pkexec*
	@echo The ettercap images belongs in ettercap-graphical
	-rm --verbose debian/ettercap-common/usr/share/ettercap/*.png
	-rm --verbose debian/ettercap-common/usr/share/ettercap/*.svg

override_dh_installdocs:
	dh_installdocs -pettercap-common
	dh_installdocs -Nettercap-common --link-doc=ettercap-common

=== debian/watch ===
version=4

https://ettercap.github.com/downloads.html \
(?:.*[/=]|)ettercap-(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz)).*
